

 comment *
 -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

     Displays info from the LOGFONT structure after a font has been selected from
     the ChooseFont Dialog.
     uses a modeless dialogbox & an edit control to display the info

 ========================================================================================== *

    .586                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\macros\macros.asm
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc
    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\oleaut32.lib
    includelib \masm32\lib\msvcrt.lib

    DlgBox PROTO :DWORD, :DWORD, :DWORD, :DWORD


    .data?


    .data

        hinstance         dd     0
        hdlg              dd     0
        hdc               dd     0
        hdlg_brush        dd     0
        hedit_brush       dd     0


        choosefont    CHOOSEFONT    <0>
        logfont        LOGFONT      <0>             ;  Logical Font structure
        msg              MSG        <0>

        dlgtemplatebuff   dd    1024 dup(0)         ; dlg template buffer - needs to be dword aligned
        lf_displaybuff    db    2048 dup (0)

        dlgboxtitle       db    "LOGFONT Info ",0
        button_title      db    "OK",0
        editbox_text      db    " ",0
        font_name         db    "fixedsys",0

; -------------------------------------------------------------------------------------------


    .code

start:
  

    invoke GetModuleHandle, 0
    mov hinstance, eax

 ; ===================================================================== 
 ;     fill in the CHOOSEFONT structure
 ; ===================================================================== 

    mov choosefont.lStructSize,  SIZEOF choosefont
    mov choosefont.hwndOwner  ,      0
    mov choosefont.hDC,              0
    mov choosefont.lpLogFont,    offset logfont
    mov choosefont.iPointSize,       0
    mov choosefont.Flags,        CF_SCREENFONTS or CF_EFFECTS
    mov choosefont.rgbColors,        0
    mov choosefont.lCustData,        0
    mov choosefont.lpfnHook,         0
    mov choosefont.lpTemplateName,   0
    mov choosefont.hInstance,        0
    mov choosefont.lpszStyle,        0         
    mov choosefont.nFontType,    SCREEN_FONTTYPE
    mov choosefont.nSizeMin,         0 
    mov choosefont.nSizeMax,         0    

                                               ; =============================================
    invoke ChooseFont, addr choosefont         ; creates a font dialogbox
    cmp eax, 0                                 ; this section checks the result & for errors
  ; ------------------------------------------------------------------------------------------    
    jz clickcancel
    fn MessageBox, 0, "Clicked  O K", "Font Box", MB_OK
    jmp @F    
  clickcancel:
    invoke CommDlgExtendedError
    cmp eax, 0  
    jnz fontdlg_error
    fn MessageBox, 0, "Clicked  Cancel", "Font Box", MB_OK
    jmp @F
  fontdlg_error:
    fn MessageBox, 0, "Font Dialog Error !!!", "Font Box", MB_OK
    jmp end_
  ; ------------------------------------------------------------------------------------  

  @@:


    mov esi, offset lf_displaybuff

    mov ebx, logfont.lfHeight
    invoke wsprintf, esi, chr$("lfHeight:  %ld",13,10), ebx
    add esi, eax                               ; number of bytes retnd in eax to the address

    mov ebx, logfont.lfWidth
    invoke wsprintf, esi, chr$("lfWidth:  %ld",13,10), ebx
    add esi, eax                          

    mov ebx, logfont.lfEscapement
    invoke wsprintf, esi, chr$("Escapement:  %ld",13,10), ebx
    add esi, eax                          

    mov ebx, logfont.lfOrientation
    invoke wsprintf, esi, chr$("Orientation:  %ld",13,10), ebx
    add esi, eax                          

    mov ebx, logfont.lfWeight
    invoke wsprintf, esi, chr$("lfWeight:  %ld",13,10), ebx
    add esi, eax                          

    movzx ebx, logfont.lfItalic
    cmp ebx, 0
    jnz lfItalic_true
    invoke wsprintf, esi, chr$("lfItalic:  %s",13,10), chr$("False")
    add esi, eax                          
    jmp @F
  lfItalic_true:
    invoke wsprintf, esi, chr$("lfItalic:  %s",13,10), chr$("True")
    add esi, eax                          
  @@:

    movzx ebx, logfont.lfUnderline
    cmp ebx, 0
    jnz lfUnderline_true
    invoke wsprintf, esi, chr$("lfUnderline:  %s",13,10), chr$("False")
    add esi, eax                          
    jmp @F
  lfUnderline_true:
    invoke wsprintf, esi, chr$("lfUnderline:  %s",13,10), chr$("True")
    add esi, eax
  @@:

    movzx ebx, logfont.lfStrikeOut
    cmp ebx, 0
    jnz lfStrikeOut_true
    invoke wsprintf, esi, chr$("lfStrikeOut:  %hs",13,10), chr$("False")
    add esi, eax                          
    jmp @F
  lfStrikeOut_true:
    invoke wsprintf, esi, chr$("lfStrikeOut:  %s",13,10), chr$("True")
    add esi, eax                          
  @@:


    movzx ebx, logfont.lfCharSet
    invoke wsprintf, esi, chr$("lfCharSet:  %lu",13,10), ebx
    add esi, eax                          

    movzx ebx, logfont.lfOutPrecision
    invoke wsprintf, esi, chr$("lfOutPrecision:  %lu",13,10), ebx
    add esi, eax                          

    movzx ebx, logfont.lfClipPrecision
    invoke wsprintf, esi, chr$("lfClipPrecision:  %lu",13,10), ebx
    add esi, eax                          

    movzx ebx, logfont.lfQuality
    invoke wsprintf, esi, chr$("lfQuality:  %lu",13,10), ebx
    add esi, eax                          

    movzx ebx, logfont.lfPitchAndFamily
    invoke wsprintf, esi, chr$("lfPitchAndFamily:  %lu",13,10), ebx
    add esi, eax                          

    mov ebx, offset logfont.lfFaceName
    invoke wsprintf, esi, chr$("lfFaceName:  %s",13,10), ebx
    add esi, eax                          


  ; =======================================================
  ;   Create the dialog box
  ; =======================================================

    call create_templates
    invoke CreateDialogIndirectParam, hinstance, addr dlgtemplatebuff, 0,  DlgBox, 0
    mov hdlg, eax                         ; handle to the dialog


    Messageloop:

      invoke GetMessage, addr msg, hdlg, 0, 0

        .if eax == SDWORD PTR -1  
            fn MessageBox,0,"error","Title",MB_OK
            jmp ExitMsgLoop
  
        .elseif eax == 0
            jmp ExitMsgLoop
  
        .else
            invoke IsDialogMessage, hdlg, addr msg     ; provides a keyboard interface for modeless dialog-boxes.
            cmp eax, 0                                 ; eax != 0 means the message has been processed.
            jnz @F
            invoke TranslateMessage, addr msg
            invoke DispatchMessage, addr msg
         @@:
        .endif                                         

        jmp Messageloop

    ExitMsgLoop:
          mov eax, msg.wParam
          invoke ExitProcess, 0
          ret


;                              dialogbox  procedure
; -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  

  DlgBox proc hWndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
  
  
         .if uMsg == WM_COMMAND                    ; lParam = handle of control
             movzx ecx, word ptr [wParam]          ; low word of wParam - control identifier
             movzx ebx, word ptr [wParam+2]        ; high word of wParam - notification msg
  
             .if ecx == IDCANCEL
                 jmp end_dialog
             .else
                 jmp false_
             .endif
  
  
         .elseif uMsg == WM_INITDIALOG             
             invoke SetDlgItemText, hWndDlg, 100, addr lf_displaybuff

             jmp false_                             

     ; =====================================
     ;    sets the dialog's colour
     ; ====================================== 
         .elseif uMsg == WM_CTLCOLORDLG
             mov edx, wParam
             mov hdc, edx

             xor edx, edx
             mov dl, 217                           ; blue
             rol edx, 16
             mov dl, 166                           ; red
             mov dh, 209                           ; green
             
             invoke CreateSolidBrush, edx
             mov hdlg_brush, eax
             invoke SelectObject, wParam, eax
             return hdlg_brush 

         .elseif uMsg == WM_CTLCOLOREDIT 
             xor edx, edx
             mov dl, 217                           ; blue
             rol edx, 16
             mov dl, 166                           ; red
             mov dh, 221                           ; green

             invoke CreateSolidBrush, edx
             mov hedit_brush, eax
             invoke SelectObject, wParam, eax

             return hedit_brush 

  
         .elseif uMsg == WM_DESTROY
             invoke SelectObject, hdc, hedit_brush
             invoke DeleteObject, hedit_brush
             invoke SelectObject, hdc, hdlg_brush
             invoke DeleteObject, hdlg_brush
             invoke PostQuitMessage, NULL
             jmp true_
  
         .elseif uMsg == WM_CLOSE
             jmp end_dialog   
  
         .else
             jmp false_                            ; default processing
                             
         .endif    
  
  
      end_dialog:
        
        invoke DestroyWindow, hWndDlg
  
      true_:                                    ; dlg proc processed the msg TRUE
         mov eax, 1                             ; return true (for processing a msg)
         jmp ret_
                        
      false_:                                   ; to direct the system to process the msg
         xor eax, eax                           ; return false (proc didn't process the msg)
          
  
      ret_:    
        ret
    
  DlgBox endp


    create_templates:
; =============================== dialogbox template ==========================================

    mov edi, offset dlgtemplatebuff            ; addr of the dialog template
                                               ; style
    mov dword ptr [edi+0],   WS_POPUP or WS_SYSMENU or WS_CAPTION or WS_VISIBLE or DS_SETFONT
    mov dword ptr [edi+4],      0              ; extended styles
    mov  word ptr [edi+8],      1              ; control item-count
    mov  word ptr [edi+10],     100            ; x co-ordinate
    mov  word ptr [edi+12],     100            ; y co-ordinate
    mov  word ptr [edi+14],     200            ; width
    mov  word ptr [edi+16],     150            ; height

    mov  word ptr [edi+18],      0             ; Menu array   (0 = no menu)
    mov  word ptr [edi+20],      0             ; Class array  (0 = predifined dialogbox class)

    add edi,  22                               ; Title array start address
    invoke MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, addr dlgboxtitle, -1,
                                edi, LENGTHOF dlgboxtitle
    add edi, LENGTHOF dlgboxtitle*2
  ; ------------------------------------------ ; 16-bit value when the DS_SETFONT style is specified
    mov word ptr [edi],          9             ; point size value of the font
    add edi,  2
 
    invoke MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, addr font_name, -1,
                                edi, LENGTHOF font_name
    add edi, LENGTHOF font_name*2

; ============================== multiline editbox ============================================

       memalign edi, 4
       mov dword ptr [edi+0] ,   ES_MULTILINE or ES_LEFT or ES_AUTOHSCROLL or ES_AUTOVSCROLL or WS_CHILD or WS_VISIBLE    
       mov dword ptr [edi+4] ,   0           ;  extended style
       mov  word ptr [edi+8] ,   20          ;  x-coordinate
       mov  word ptr [edi+10],   10          ;  y-coordinate
       mov  word ptr [edi+12],   150         ;  width , in dialog box units, of the control
       mov  word ptr [edi+14],   110         ;  height, in dialog box units, of the control
       mov  word ptr [edi+16],   100         ;  control identifier (255 max)

       mov word ptr [edi+18], 65535         
       mov word ptr [edi+20], 129            ; signifies a 'EDIT' class for the control

; ============ title array ===================
                                               
       add edi, 22
       invoke MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, addr editbox_text, -1,
                                   edi, LENGTHOF editbox_text*2
       add edi, LENGTHOF editbox_text*2


;      creation data
; ============================================
       memalign edi, 4
       mov dword ptr [edi],  0                ;  creation data
       add edi           ,   4

    ret

; ===========================================================================================



  end_:
    invoke ExitProcess, 0


end start









